diff --git a/plugins/check_http.c b/plugins/check_http.c
index 718fb84..6f9fea2 100644
--- a/plugins/check_http.c
+++ b/plugins/check_http.c
@@ -783,15 +783,14 @@ check_http (void)
   }
 #endif /* HAVE_SSL */
 
-  asprintf (&buf, "%s %s HTTP/1.0\r\n%s\r\n", http_method, server_url, user_agent);
+  if (host_name)
+    asprintf (&buf, "%s %s HTTP/1.1\r\nHost: %s:%d\r\n%s\r\n", http_method, server_url, host_name, server_port, user_agent);
+  else
+    asprintf (&buf, "%s %s HTTP/1.0\r\n%s\r\n", http_method, server_url, user_agent);
 
   /* tell HTTP/1.1 servers not to keep the connection alive */
   asprintf (&buf, "%sConnection: close\r\n", buf);
 
-  /* optionally send the host header info */
-  if (host_name)
-    asprintf (&buf, "%sHost: %s:%d\r\n", buf, host_name, server_port);
-
   /* optionally send any other header tag */
   if (http_opt_headers_count) {
     for (i = 0; i < http_opt_headers_count ; i++) {
